/***************************************************************
 * Name:      dialogo.cpp
 * Purpose:   Code for Dialog spinControl
 * Author:    Salvador Pozo (salvapozo@gmail.com)
 * Created:   2024-11-09
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#include "dialogo.h"

wxBEGIN_EVENT_TABLE(dialogo, wxDialog)
    EVT_CLOSE(dialogo::OnClose)
    EVT_BUTTON(wxID_OK, dialogo::OnOk)
wxEND_EVENT_TABLE()

dialogo::dialogo(wxWindow *wnd, datosDialogo &datos)
    : wxDialog(wnd, -1, _T("Ejemplo de validador")), data(datos)
{
    wxBoxSizer *boxVertical;
    wxBoxSizer *boxHorizontal;
//    paresValidator validador(&data.enteropar);

    boxVertical = new wxBoxSizer(wxVERTICAL);

    boxHorizontal = new wxBoxSizer(wxHORIZONTAL);
    m_textCtrl = new wxTextCtrl(this, idTextCtrl, wxEmptyString, wxDefaultPosition, wxSize(200, wxDefaultCoord), 0, paresValidator(&data.enteropar));
    boxHorizontal->Add(m_textCtrl, wxSizerFlags().Border());
    boxVertical->Add(boxHorizontal, wxSizerFlags().Border(wxTOP).Right());

    boxVertical->Add(CreateStdDialogButtonSizer(wxOK | wxCANCEL), wxSizerFlags().Border());

    SetSizerAndFit(boxVertical);
}

dialogo::~dialogo()
{
    //dtor
}

void dialogo::OnClose(wxCloseEvent& event) {
    Destroy();
}

void dialogo::OnOk(wxCommandEvent& event) {
    if ( Validate() && TransferDataFromWindow() ) EndModal(wxID_OK);
}

