/***************************************************************
 * Name:      paresvalidator.cpp
 * Purpose:   Code for paresValidator
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-11-010
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#include "paresvalidator.h"

IMPLEMENT_DYNAMIC_CLASS( paresValidator, wxValidator )
BEGIN_EVENT_TABLE( paresValidator, wxValidator )
END_EVENT_TABLE()

paresValidator::paresValidator(int *n) : wxValidator(), m_numeropar(n) {}

bool paresValidator::TransferFromWindow()
{
    wxString cad;
    try {
        wxTextCtrl *tc = dynamic_cast<wxTextCtrl*>(m_validatorWindow);
        cad = tc->GetValue();
        cad.ToInt(m_numeropar);
    }
    catch (...) {
        wxFAIL_MSG( _T("paresValidator sólo funciona con wxTextCtrl"));
        return false;
    }
    return true;
}

bool paresValidator::TransferToWindow()
{
    wxString cad = wxEmptyString;
    try {
        wxTextCtrl *tc = dynamic_cast<wxTextCtrl*>(m_validatorWindow);
        cad << *m_numeropar;
        tc->SetValue(cad);
    }
    catch(...) {
        wxFAIL_MSG( _T("paresValidator sólo funciona con wxTextCtrl"));
        return false;
    }
    return true;
}

bool paresValidator::Validate(wxWindow* parent)
{
    if (!m_validatorWindow->IsEnabled()) return true;

    wxString cad;
    int v;
    bool retval;

    try {
        wxTextCtrl *tc = dynamic_cast<wxTextCtrl*>(m_validatorWindow);
        cad = tc->GetValue();
    }
    catch (...) {
        wxFAIL_MSG( _T("paresValidator sólo funciona con wxTextCtrl"));
        return false;
    }

    cad.ToInt(&v);
    retval = v>=0 && !(v%2); // Mayor de 0 y no impar
    if(!retval) {
        wxString errmsg = wxT("Se debe introducir un valor positivo par");
        wxMessageDialog dlg(parent,errmsg,wxT("Entrada incorrecta"),wxOK);
        dlg.ShowModal();
    }

    return retval;
}

