/***************************************************************
 * Name:      wx004bMain.cpp
 * Purpose:   Code for Application Frame
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-11-10
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#include "wx004bMain.h"

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__WXMAC__)
        wxbuild << _T("-Mac");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

BEGIN_EVENT_TABLE(wx004bFrame, wxFrame)
    EVT_CLOSE(wx004bFrame::OnClose)
    EVT_MENU(idMenuQuit, wx004bFrame::OnQuit)
    EVT_MENU(idMenuAbout, wx004bFrame::OnAbout)
    EVT_MENU(idMenuDialogo, wx004bFrame::OnDialogo)
END_EVENT_TABLE()

wx004bFrame::wx004bFrame(wxFrame *frame, const wxString& title)
    : wxFrame(frame, -1, title), data(10)
{
    // create a menu bar
    wxMenuBar* mbar = new wxMenuBar();
    wxMenu* fileMenu = new wxMenu(_T(""));
    fileMenu->Append(idMenuDialogo, _("&Dialogo"), _("Ejemplo de validador"));
    fileMenu->Append(idMenuQuit, _("&Salir\tAlt-F4"), _("Salir de la aplicación"));
    mbar->Append(fileMenu, _("&Fichero"));

    wxMenu* helpMenu = new wxMenu(_T(""));
    helpMenu->Append(idMenuAbout, _("&Sobre\tF1"), _("Muestra información sobre esta aplicación"));
    mbar->Append(helpMenu, _("&Ayuda"));

    SetMenuBar(mbar);
    // create a status bar with some information about the used wxWidgets version
    CreateStatusBar(2);
    SetStatusText(_("Hola"),0);
    SetStatusText(wxbuildinfo(short_f), 1);
}


wx004bFrame::~wx004bFrame()
{
}

void wx004bFrame::OnClose(wxCloseEvent &event)
{
    Destroy();
}

void wx004bFrame::OnQuit(wxCommandEvent &event)
{
    Destroy();
}

void wx004bFrame::OnAbout(wxCommandEvent &event)
{
    wxString msg = wxbuildinfo(long_f);
    wxMessageBox(msg, _("Bienvenido a..."));
}

void wx004bFrame::OnDialogo(wxCommandEvent& event) {
    wxString cad;
    dialogo *dlg = new dialogo(this, data);
    dlg->ShowModal();
    cad << _T("Número:") << data.enteropar;
    wxMessageBox(cad, _T("Respuesta"));
}
