/***************************************************************
 * Name:      wx004bMain.h
 * Purpose:   Defines Application Frame
 * Author:    Salvador Pozo (salvador@conclase.net)
 * Created:   2024-11-10
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifndef WX004BMAIN_H
#define WX004BMAIN_H

#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif

#include "wx004bApp.h"
#include "dialogo.h"

class wx004bFrame: public wxFrame
{
    public:
        wx004bFrame(wxFrame *frame, const wxString& title);
        ~wx004bFrame();
    private:
        enum
        {
            idMenuQuit = 1000,
            idMenuAbout,
            idMenuDialogo
        };
        datosDialogo data;

        void OnClose(wxCloseEvent& event);
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnDialogo(wxCommandEvent& event);
        DECLARE_EVENT_TABLE()
};


#endif // WX004BMAIN_H
